{$M 65500, 0, 200000 }

{ In 3DI Patch, people can use 3DIGI to build the object parts, then use
this program to put them together.  As of now, I don't know how to save the
file format in a way that allows the objects to be put together, saved, and
reopened and edited.  Here are my current notes:}

{in the multi object file format, the file keeps track of the number of
objects, the object information like a normal 3DI file, except it also saves
wether or not the object has been moved up/down/left/right/in/out, and how
it was retotated if it was.  16 objects are allowed per large object.  As
for editing, the normal rotation buttons will rotate all the objects
together as if they are connected.  As for the individual objects, they are
selected by clicking on them.  A box at the top of the conrol panel will turn
the color of the object selected.  Q=7 W=8 E=9 A=4 S=6 Z=2
also the objects will need to move in the 6 dimentions which are currently
P=back L=Close ;=left '=right [=up /=down  The main object can be rotated
and the selected object rotated without needing to switch between them.
Instead the use of the keys determines what move.  Unfortunately since there
can be 16 objects, each with 256 panels max, on a bust object, the rendering
can be excrutiatingly slow.  For this reason, I'm going to add an option for
fill or no fill since the object will always have their outlines because of
the lack of shading.}
program  Imager(input,output,F,FO);{3-D Imager}
uses crt,mouse,gfx2,{TransU,}dos;
Const
  Rate = 5;
  Graphics = true;
  UseLines = false;
  Fill = true;
  vga = $a000;
  ColorMin = 120;
  ColRange = 0.7;
  MaxObj = 16;
  depthlevel = 200;
  ShiftRate = 1;
type
  BigRotType = array[0..199,0..199] of byte;
  str = string[12];
  DotT = record
              X : integer;
              Y : integer;
              Z : integer;
              C : byte;
         end;
  DotType = array [1..256] of DotT;
  TriP =  record
           P1,P2,P3 : integer;
           R,B,G : byte;
          end;

  TriLoc = array[1..256] of Trip;
  TriLocation = array[1..Maxobj] of ^TriLoc;
  SType = array [1..3] of
          record
          X,y,Z : integer;
          end;
  SpinType = array[1..256] of SType;

  TriType = array[1..256] of TriP;
  TriColor = array[1..256] of byte; {This holds the color of the
                                   polygon since I can't figure
                                   out how to add it to TriType}

  AngleType = array[-30..390] of real;
  Clr = array[1..MaxObj] of array[1..256] of byte;
  GridPosType = array[0..99,0..99] of integer;

 Virtual = Array [1..64000] of byte;  { The size of our Virtual Screen }
 VirtPtr = ^Virtual;                  { Pointer to the virtual screen }
 paltype = array[0..255] of
         record
          R,B,G: byte;
         end;
 FinalColType = array[0..255] of
                record
                  R,B,G : byte;
                end;
 OriginalType = array[0..255] of byte;

 ObjectInfoType = array[1..MaxObj] of
                  record
                        XS, YS, ZS, XR, YR, ZR : integer;
                        Name : string;
                  end;
 DotCountType = array[1..MaxObj] of integer;
 DotObjType = array[1..MaxObj] of ^DotType;
 TriCountType = array[1..MaxObj] of integer;
var
 sinemovement : integer;
   Virscr : VirtPtr;                      { Our first Virtual screen }
   Vaddr  : word;                        { The segment of our virtual screen}
  Black : byte;
  White : byte;
  Blue : byte;
  Red : byte;
  demo : boolean;
  Objects: integer; {Number of objects}
{}
Function RClick(var rc : boolean) : boolean;
 begin
  If mouseright and not(RC) then
   begin
    RC := true;
    RClick := False;
   end;
  If RC and not(mouseright) then
   begin
    RC := FALSE;
    RClick := TRUE;
   end;
  end;

Function LClick(var LC: boolean) : boolean;
 begin
  If mouseleft and not(LC) then
   begin
    LC := TRUE;
    LClick := FALSE;
   end;
  If LC and not(mouseleft) then
   begin
    LC := FALSE;
    LClick := TRUE;
   end;
  end;

procedure ClearOp;
 begin
  box(211+ 32,01,211+ 64,32,Black,VGA);
 end;

procedure selectOp(Operation : integer; var NewX,NewY,OldX,OldY:integer;var PastColor:byte);
 begin
  If operation = 7 then
   begin
    clearOp;
    putpixel(OldX + 10,OldY,PastColor,VGA);
    Box(211+ 32,00 + 00,211 + 33+ 10,00 + 10,Blue,VGA);
    PastColor := GetPixel(OldX + 10,OldY,VGA);
    putpixel(OldX + 10,OldY,White,VGA);
   end;
  If operation = 8 then
   begin
    clearOp;
    putpixel(OldX + 10,OldY,PastColor,VGA);
    Box(211 + 32 + 11,00+ 00,211 + 33 + 22,00 + 10,Blue,VGA);
    PastColor := GetPixel(OldX + 10,OldY,VGA);
    putpixel(OldX + 10,OldY,White,VGA);
   end;
  If operation = 9 then
   begin
    clearOp;
    putpixel(OldX + 10,OldY,PastColor,VGA);
    Box(210 + 32+ 23,00 + 00,210 + 33 + 33,00 + 10,Blue,VGA);
    PastColor := GetPixel(OldX + 10,OldY,VGA);
    putpixel(OldX + 10,OldY,White,VGA);
   end;

  If operation = 4 then
   begin
    clearOp;
    putpixel(OldX + 10,OldY,PastColor,VGA);
    Box(211+ 32,00 + 11,211 + 33+ 10,00 + 22,Blue,VGA);
    PastColor := GetPixel(OldX + 10,OldY,VGA);
    putpixel(OldX + 10,OldY,White,VGA);
   end;
  If operation = 5 then
   begin
    clearOp;
    putpixel(OldX + 10,OldY,PastColor,VGA);
    Box(211 + 32 + 12,00+ 11,211 + 33 + 22,00 + 22,Blue,VGA);
    PastColor := GetPixel(OldX + 10,OldY,VGA);
    putpixel(OldX + 10,OldY,White,VGA);
   end;
  If operation = 6 then
   begin
    clearOp;
    putpixel(OldX + 10,OldY,PastColor,VGA);
    Box(210 + 32+ 23,00 + 11,210 + 33 + 33,00 + 21,Blue,VGA);
    PastColor := GetPixel(OldX + 10,OldY,VGA);
    putpixel(OldX + 10,OldY,White,VGA);
   end;

  If operation = 1 then
   begin
    clearOp;
    putpixel(OldX + 10,OldY,PastColor,VGA);
    Box(211+ 32,00 + 23,211 + 33+ 10,00 + 33,Blue,VGA);
    PastColor := GetPixel(OldX + 10,OldY,VGA);
    putpixel(OldX + 10,OldY,White,VGA);
   end;
  If operation = 2 then
   begin
    clearOp;
    putpixel(OldX + 10,OldY,PastColor,VGA);
    Box(211 + 32 + 11,00+ 23,211 + 33 + 22,00 + 33,Blue,VGA);
    PastColor := GetPixel(OldX + 10,OldY,VGA);
    putpixel(OldX + 10,OldY,White,VGA);
   end;
  If operation = 3 then
   begin
    clearOp;
    putpixel(OldX + 10,OldY,PastColor,VGA);
    Box(210 + 32+ 23,00 + 23,210 + 33 + 33,00 + 33,Blue,VGA);
    PastColor := GetPixel(OldX + 10,OldY,VGA);
    putpixel(OldX + 10,OldY,White,VGA);
   end;
end;

Procedure ChooseOperation(var NewX,newY,OldX,OldY,Operation: integer; var pastcolor : byte;var lc,rc : boolean);
 begin
  If LClick(lc) and (mouseleft) and (OldX+10 >= 210) and (OldX+10 <= 210 + 32) and (OldY <= 32)
     and (Operation <> 7) then
  BEGIN
   Operation := 7;
   selectOp(Operation,NewX,NewY,OldX,OldY,PastColor);
  END;

  If LClick(lc) and (mouseleft) and (OldX+10 >= 210 + 33) and (OldX+10 <= 210 + 63) and (OldY <= 32)
     and (Operation <> 8) then
  BEGIN
   Operation := 8;
   selectOp(Operation,NewX,NewY,OldX,OldY,PastColor);
  END;

  If LClick(lc) and (mouseleft) and (OldX+10 >= 210 + 64) and (OldX+10 <= 210 + 99) and (OldY <= 32)
     and (Operation <> 9) then
  BEGIN
   Operation := 9;
   selectOp(Operation,NewX,NewY,OldX,OldY,PastColor);
  END;

  If LClick(lc) and (mouseleft) and (OldX+10 >= 210) and (OldX+10 <= 210 + 32) and (OldY <= 66) and (OldY >= 33)
     and (Operation <> 4) then
  BEGIN
   Operation := 4;
   selectOp(Operation,NewX,NewY,OldX,OldY,PastColor);
  END;

  If LClick(lc) and (mouseleft) and (OldX+10 >= 210 + 33) and (OldX+10 <= 210 + 63) and (OldY <= 66) and (OldY >= 33)
     and (Operation <> 5) then
  BEGIN
   Operation := 5;
   selectOp(Operation,NewX,NewY,OldX,OldY,PastColor);
  END;

  If LClick(lc) and (mouseleft) and (OldX+10 >= 210 + 64) and (OldX+10 <= 210 + 99) and (OldY <= 66) and (OldY >= 33)
     and (Operation <> 6) then
  BEGIN
   Operation := 6;
   selectOp(Operation,NewX,NewY,OldX,OldY,PastColor);
  END;

  If LClick(lc) and (mouseleft) and (OldX+10 >= 210) and (OldX+10 <= 210 + 32) and (OldY <= 99) and (OldY >= 67)
     and (Operation <> 1) then
  BEGIN
   Operation := 1;
   selectOp(Operation,NewX,NewY,OldX,OldY,PastColor);
  END;

  If LClick(lc) and (mouseleft) and (OldX+10 >= 210 + 33) and (OldX+10 <= 210 + 63) and (OldY <= 99) and (OldY >= 67)
     and (Operation <> 2) then
  BEGIN
   Operation := 2;
   selectOp(Operation,NewX,NewY,OldX,OldY,PastColor);
  END;

  If LClick(lc) and (mouseleft) and (OldX+10 >= 210 + 64) and (OldX+10 <= 210 + 99) and (OldY <= 99) and (OldY >= 67)
     and (Operation <> 3) then
  BEGIN
   Operation := 3;
   selectOp(Operation,NewX,NewY,OldX,OldY,PastColor);
  END;

 end;

procedure MouseStuff(var NewX,NewY,OldX,OldY: integer;var PastColor,MouseColor :byte);
begin
{  NewX := mousex; NewY := mousey;   }
  NewX := mousex - 10; NewY := mousey;
  If ((OldY <> NewY) or (OldX <> NewX)) then
   begin
    putpixel(OldX+ 10,OldY,PastColor,VGA);
    PastColor := getpixel(NewX+ 10,NewY,VGA);
    putpixel(NewX+ 10,NewY,MouseColor,VGA);
   end;
  If OldX <> NewX then
   OldX := NewX;
  If OldY <> NewY then
   OldY := NewY;
end;
Procedure SetUpVirtual;
   { This sets up the memory needed for the virtual screen }
BEGIN
  GetMem (VirScr,64000);
  vaddr := seg (virscr^);
END;

Procedure FlipVGA;
   { This flips the virtual screen to the VGA screen. }
BEGIN
  Move (Virscr^,mem [VGA:0],64000);
END;

Procedure FlipVdr;
   { This flips the virtual screen to the VGA screen. }
BEGIN
  Move (mem [VGA:0],Virscr^,64000);
END;

Procedure Cls (Col : Byte; Where:Word);
   { This clears the screen to the specified color, on the VGA or on the
        virtual screen }
BEGIN
  Fillchar (Mem [where:0],64000,col);
END;
{}

procedure clear;
 var x : integer;
 begin
  line(210,0,310,0,Blue,vga);
  line(210,99,310,99,Blue,vga);
  line(210,0,210,99,Blue,vga);
  line(310,0,310,99,Blue,vga);
 end;

procedure clearbox;
 begin
  box(211+ 32,34,211+ 64,65,Black,VGA);
 end;

function getkey : char;
  var temp : char;
  begin
    temp := chr(0);
    if KeyPressed then
      temp := ReadKey;  { Swallow extended keystrokes }
    getkey := temp;
  end;

procedure select(section : integer; var NewX,NewY,OldX,OldY:integer;var PastColor:byte);
 const
  SecX = 0;
  SecY = 0;
 begin
  If section = 8 then
   begin
    clearbox;
   putpixel(OldX + SecX + 10,OldY + SecY,PastColor,VGA);
    Box(211 + 32 + 11,33 + 01,211 + 33 + 22,33 + 11,Blue,VGA);
    PastColor := GetPixel(OldX + SecX + 10,OldY + SecY,VGA);
    putpixel(OldX + SecX + 10,OldY + SecY,White,VGA);
   end;
  If section = 5 then
   begin
    clearbox;
    putpixel(OldX + SecX + 10,OldY + SecY,PastColor,VGA);
    Box(211 + 32 + 11,33+ 11,211 + 33 + 22,33 + 22,Blue,VGA);
    PastColor := GetPixel(OldX + SecX + 10,OldY + SecY,VGA);
    putpixel(OldX + SecX + 10,OldY + SecY,White,VGA);
   end;
  If section = 4 then
   begin
    clearbox;
    putpixel(OldX + SecX + 10,OldY + SecY,PastColor,VGA);
    Box(211+ 32,33 + 11,211 + 33+ 11,33 + 22,Blue,VGA);
    PastColor := GetPixel(OldX + SecX + 10,OldY + SecY,VGA);
    putpixel(OldX + SecX + 10,OldY + SecY,White,VGA);
   end;
  If section = 6 then
   begin
    clearbox;
    putpixel(OldX + SecX + 10,OldY + SecY,PastColor,VGA);
    Box(210 + 33+ 22,33 + 11,210 + 33 + 32,33 + 22,Blue,VGA);
    PastColor := GetPixel(OldX + SecX + 10,OldY + SecY,VGA);
    putpixel(OldX + SecX + 10,OldY + SecY,White,VGA);
   end;
 end;



procedure drawdots(size:integer; DotInfo: DotType;MarkColor : byte);
 var
  a,b : integer;
 begin
  for a := 1 to (size) do
{   if (DotInfo[a].X<>0) and (DotInfo[a].Y<>0) and (DotInfo[a].Z<>0) then   }
     begin
       putpixel(DotInfo[a].X + 110,ABS(DotInfo[a].Y - 99) + 100,MarkColor,VGA);
       putpixel(ABS(DotInfo[a].Z-99) + 10,ABS(DotInfo[a].Y-99) + 100,MarkColor,VGA);
       putpixel(DotInfo[a].X + 110,ABS(DotInfo[a].Z-99),MarkColor,VGA);
       putpixel(DotInfo[a].Z + 210,abs(DotInfo[a].Y-99) + 100,MarkColor,VGA);
     end;
 end;

procedure Load(var infile: text; var count : integer; var Dot : DotType{; var Side : SideType});
var
 x : integer;
 begin
  readln(infile,Count);
  for x := 1 to Count do
  begin
   readln(infile,Dot[x].X,Dot[x].Y,Dot[x].Z,Dot[x].C);
  end;
 end;

procedure LoadTri(var infile: text; ObjectCount : integer; var TriInfo : TriLocation;var  TriSize : integer);
var
 x,y : integer;
begin
 readln(infile,TriSize);
 for x := 1 to TriSize do
  readln(infile,TriInfo[ObjectCount]^[x].P1,TriInfo[ObjectCount]^[x].P2,TriInfo[ObjectCount]^[x].P3,
    TriInfo[ObjectCount]^[x].R,TriInfo[ObjectCount]^[x].B,TriInfo[ObjectCount]^[x].G);
end;



procedure rotate(size:integer;DotXYZ:dotType;rx,ry,rz,zoom:real;Lin:boolean;TriInfo:TriLocation;sn,cs:AngleType;
          Color : Clr;TriSize : integer;var GridInfo : GridPosType;
          var original : originaltype;big : boolean;
          var NewX,newY,OldX,OldY,Operation : integer;
          var pastcolor: byte; var lc,rc: boolean;ObjectCount: integer;objectInfo : objectinfotype);

var
 x,y,z,x1,y1,z1,x2,y2,xc,yc,zc : real;
 xs,ys,zs,x1s,y1s,z1s,x2s,y2s,xcs,ycs,zcs : real;
 xt,yt,zt,x1t,y1t,z1t,x2t,y2t,xct,yct,zct : real;
 XX1,YY1,ZZ1,XX2,YY2,ZZ2,Dist1,Dist2 : real;
 l,count : integer;
 SpinTri : SpinType;
 SpinCol : array[1..256] of TriP;
 TempCol : TriP;
 TriCol : TriP;
 TriTrans : SType;
 Comp1,Comp2 : integer;
 Dist : array[1..256] of real;
 DistTmp : real;
 OutSide : boolean;
 testout : byte;
 FinalCol : FinalColType;
 ClearX,ClearY : integer;
 TempOrig : byte;
 SkipX,SkipY : integer;
 ZoomSize : real;
begin
 ZoomSize := Zoom * 0.6;
 if lin then
 begin
  SkipX := 100;
  SkipY := 100;
 end
 else
 begin
  SkipX := 60;
  SkipY := 50;
 end;
 for ClearX := 0 to 255 do
  Original[ClearX] := ClearX;

 for ClearX := 0 to 99 do
  for ClearY := 0 to 99 do
   GridInfo[ClearX,ClearY] := -1;
 flipVdr;
 If not(lin) then
  box(11,0,110,98,Black,vaddr);
{ IF (big) then }
 BEGIN

{  delay(500);   }
  for count := 1 to Size do
  begin
   DotXYZ[count].X := DotXYZ[count].X + ObjectInfo[ObjectCount].XS;
   DotXYZ[count].Y := DotXYZ[count].Y + ObjectInfo[ObjectCount].YS;
   DotXYZ[count].Z := DotXYZ[count].Z + ObjectInfo[ObjectCount].ZS;
  end;
 END;

  xc := 0;
  yc := 0;
  zc := depthlevel;
 for count := 1 to TriSize do
 begin
  x := (abs(99 - DotXYZ[TriInfo[ObjectCount]^[count].P1].x) - 50) * 1; {Here are some notes the x,y,x := are}
{  x := ((DotXYZ[TriInfo[count].P1].x) - 50) * 1;} {Here are some notes the x,y,x := are}
  y := (abs(99 - DotXYZ[TriInfo[ObjectCount]^[count].P1].y) - 50) * 1  ; {to convert my 0 -99 to}
  z := ((DotXYZ[TriInfo[ObjectCOunt]^[count].P1].Z - 50) * 1) ; {-50 - 50... or so}
       If not(graphics) then
        writeln('rx:',rx: 1 : 3,' ry:',ry: 1 : 3,' rz:',rz: 1 : 3);
  x1 := round(cs[ trunc(ry) ] * x  - sn[ trunc(ry) ] * z);
  z1 := round(sn[ trunc(ry) ] * x + cs[ trunc(ry) ] * z);
  x  := round(cs[ trunc(rz) ] * x1 + sn[ trunc(rz) ] * y);
  y1 := round(cs[ trunc(rz) ] * y  - sn[ trunc(rz) ] * x1);
  z  := round(cs[ trunc(rx) ] * z1 - sn[ trunc(rx) ] * y1);
  y  := round(sn[ trunc(rx) ] * z1 + cs[ trunc(rx) ] * y1);
  x2 := trunc((xc * z - x * zc) / (z - zc));
  y2 := trunc((yc * z - y * zc) / (z - zc));


  xs := (abs(99 - DotXYZ[TriInfo[Objectcount]^[count].P2].X) - 50) * 1; {Here are some notes the x,y,x := are}
{  xs := ((DotXYZ[TriInfo[count].P2].X) - 50) * 1;} {Here are some notes the x,y,x := are}
  ys := (abs(99 - DotXYZ[TriInfo[Objectcount]^[count].P2].Y) - 50) * 1  ; {to convert my 0 -99 to}
  zs := ((DotXYZ[TriInfo[Objectcount]^[count].P2].Z - 50) * 1) ; {-50 - 50... or so}
  xcs := 0;
  ycs := 0;
  zcs := depthlevel;
  x1s := round(cs[ trunc(ry) ] * xs  - sn[ trunc(ry) ] * zs);
  z1s := round(sn[ trunc(ry) ] * xs  + cs[ trunc(ry) ] * zs);
  xs  := round(cs[ trunc(rz) ] * x1s + sn[ trunc(rz) ] * ys);
  y1s := round(cs[ trunc(rz) ] * ys  - sn[ trunc(rz) ] * x1s);
  zs  := round(cs[ trunc(rx) ] * z1s - sn[ trunc(rx) ] * y1s);
  ys  := round(sn[ trunc(rx) ] * z1s + cs[ trunc(rx) ] * y1s);
  x2s := trunc((xcs * zs - xs * zcs) / (zs - zcs));
  y2s := trunc((ycs * zs - ys * zcs) / (zs - zcs));

  xt := (abs(99 - DotXYZ[TriInfo[Objectcount]^[count].P3].X) - 50) * 1; {Here are some notes the x,y,x := are}
{  xt := ((DotXYZ[TriInfo[count].P3].X) - 50) * 1;} {Here are some notes the x,y,x := are}
  yt := (abs(99 - DotXYZ[TriInfo[Objectcount]^[count].P3].Y) - 50) * 1  ; {to convert my 0 -99 to}
  zt := ((DotXYZ[TriInfo[Objectcount]^[count].P3].Z - 50) * 1) ; {-50 - 50... or so}
  xct := 0;
  yct := 0;
  zct := depthlevel;
  x1t := round(cs[ trunc(ry) ] * xt  - sn[ trunc(ry) ] * zt);
  z1t := round(sn[ trunc(ry) ] * xt  + cs[ trunc(ry) ] * zt);
  xt  := round(cs[ trunc(rz) ] * x1t + sn[ trunc(rz) ] * yt);
  y1t := round(cs[ trunc(rz) ] * yt  - sn[ trunc(rz) ] * x1t);
  zt  := round(cs[ trunc(rx) ] * z1t - sn[ trunc(rx) ] * y1t);
  yt  := round(sn[ trunc(rx) ] * z1t + cs[ trunc(rx) ] * y1t);
  x2t := trunc((xct * zt - xt * zct) / (zt - zct));
  y2t := trunc((yct * zt - yt * zct) / (zt - zct));

  SpinTri[count,1].X := trunc(X2);
  SpinTri[count,1].Y := trunc(Y2);
  SpinTri[count,1].Z := trunc(Z);
  SpinTri[count,2].X := trunc(X2s);
  SpinTri[count,2].Y := trunc(Y2s);
  SpinTri[count,2].Z := trunc(Zs);
  SpinTri[count,3].X := trunc(X2t);
  SpinTri[count,3].Y := trunc(Y2t);
  SpinTri[count,3].Z := trunc(Zt);
  SpinCol[count] := TriInfo[Objectcount]^[count];
 END;
{}

{    for comp1 := 1 to TriSize do
     BEGIN
        zz1:= (SpinTri[Comp1,1].z+SpinTri[Comp1,2].z+SpinTri[Comp1,3].z)/3;
        Dist[comp1] := -zz1;
     END;      }
{    For Comp1 := 1 to TriSize do
     BEGIN
      For Comp2 := Comp1+1 to TriSize do
      begin

       begin
        If Dist[comp1] < Dist[comp2] then
        begin
         TriTrans := SpinTri[Comp1];
         SpinTri[Comp1] := SpinTri[Comp2];
         SpinTri[Comp2] := triTrans;
         DistTmp := Dist[comp1];
         Dist[comp1] := DIst[comp2];
         Dist[comp2] := DistTmp;

         TempCol := SpinCol[comp1];
         SpinCol[comp1] := SpinCol[Comp2];
         SpinCol[comp2] := TempCol;
         TempOrig := Original[comp1];
         Original[comp1] := Original[comp2];
         Original[comp2] := TempOrig;
        end;
        end;
       end;
      end; }

   begin
    If Lin then
  {   box(0,0,199,199,0,vaddr);  }
     for comp1 := 1 to trisize do
     BEGIN
      outside := FALSE;
      for testout := 1 to 3 do
       begin
        If lin then
        begin
         If ((SpinTri[Comp1,testout].x *zoomsize + SkipX) < 0) or
          ((SpinTri[Comp1,testout].x *zoomsize + SkipX) > 200) then outside := TRUE;
         If ((SpinTri[Comp1,testout].y *zoomsize + SkipY) < 0) or
          ((SpinTri[Comp1,testout].y *zoomsize + SkipY) > 200) then outside := TRUE;
        end;
        if not(lin) then
        begin
         If ((SpinTri[Comp1,testout].x *zoomsize + SkipX) <= 10) or
          ((SpinTri[Comp1,testout].x *zoomsize + SkipX) > 110) then outside := TRUE;
         If ((SpinTri[Comp1,testout].y *zoomsize + SkipY) < 0) or
          ((SpinTri[Comp1,testout].y *zoomsize + SkipY) >= 100) then outside := TRUE;
        end;
       end;
      If (not(outside)) then
      beGin
   {    If (Fill) then  }
       BEGIN
    {    DrawPoly(
        trunc(( SpinTri[Comp1,1].x )*0.60 * ZOOM + SkipX),
        trunc(( SpinTri[Comp1,1].y )*0.60 * ZOOM + SkipY),
        trunc(( SpinTri[Comp1,2].x )*0.60 * ZOOM + SkipX),
        trunc(( SpinTri[Comp1,2].y )*0.60 * ZOOM + SkipY),
        trunc(( SpinTri[Comp1,3].x )*0.60 * ZOOM + SkipX),
        trunc(( SpinTri[Comp1,3].y )*0.60 * ZOOM + SkipY),
        trunc(( SpinTri[Comp1,1].x )*0.60 * ZOOM + SkipX),
        trunc(( SpinTri[Comp1,1].y )*0.60 * ZOOM + SkipY),
        ObjectCount,vaddr);   }

 {
        FinalCol[comp1].R := round(SpinCol[Comp1].R*abs(Dist[comp1]-100)/200);
        FinalCol[comp1].B := round(SpinCol[Comp1].B*abs(Dist[comp1]-100)/200);
        FInalCol[comp1].G := round(SpinCol[Comp1].G*abs(Dist[comp1]-100)/200);
  }
       END;

 {      If UseLines then }
       begin
        Line(
        trunc(( SpinTri[Comp1,1].x )*ZOOMsize + SkipX),
        trunc(( SpinTri[Comp1,1].y )*ZOOMsize + SkipY),
        trunc(( SpinTri[Comp1,2].x )*ZOOMsize + SkipX),
        trunc(( SpinTri[Comp1,2].y )*ZOOMsize + SkipY),
        ObjectCount,vaddr);
        Line(
        trunc(( SpinTri[Comp1,2].x )*ZOOMsize + SkipX),
        trunc(( SpinTri[Comp1,2].y )*ZOOMsize + SkipY),
        trunc(( SpinTri[Comp1,3].x )*ZOOMsize + SkipX),
        trunc(( SpinTri[Comp1,3].y )*ZOOMsize + SkipY),
        ObjectCount,vaddr);
        Line(
        trunc(( SpinTri[Comp1,3].x )*ZOOMsize + SkipX),
        trunc(( SpinTri[Comp1,3].y )*ZOOMsize + SkipY),
        trunc(( SpinTri[Comp1,1].x )*ZOOMsize + SkipX),
        trunc(( SpinTri[Comp1,1].y )*ZOOMsize + SkipY),
        ObjectCount,vaddr);
       end;
      eNd;
    END;
   end;
   flipvga;
        { - 50 is the center of the grid 0 is the front of the box
         50,50,0 X,Y,Z is the viewing point}

{   for comp1 := 1 to TriSize do
    pal(comp1,FinalCol[comp1].R,FinalCol[comp1].B,FinalCol[comp1].G);  }

 end;
{}{}{}{}{}{}{}{}
Procedure ChooseObject(var lc:boolean;OldX,OldY: integer;
                           var ObjectSelected: boolean; pastcolor: byte;
                           var objectnumber : byte);
begin
  If LClick(lc) and (mouseleft) and (OldX+10 >= 10) and (OldX+10 <= 210) then
  BEGIN
   ObjectSelected := true;
   sound(500);
   delay(200);
   nosound;
   putpixel(OldX + 10,OldY,PastColor,VGA);
   Box(211 + 32 + 11, 1 ,211 + 33 + 22,00 + 10,pastcolor,VGA);
   ObjectNumber := pastcolor;
  end;
end;
{This section has yet to be completed, but when a person clicks on the main
rotation screen, it will grab a color from one of the objects, and that
color's number will correspond to an object number.  Once the object has been
selected, area 8 of the selection box will turn that color, and the object
can be moved}
{}{}{}{}{}{}{}{}
procedure Rotation(dotcount:dotcounttype;DotXYZ:DotObjType;
          var rx,ry,rz:integer;
          var zoom:real;Lin:boolean;TriInfo:TriLocation;
          sn,cs:AngleType; Color:Clr; TriSize:TriCountType;
          var NewX,NewY,OldX,OldY: integer; var PastColor:byte;
          var lc,rc : boolean;var operation : integer;objects : integer;
          var ObjectInfo: objectInfoType);
var
  ch : char;
  az,ax,ay : real;
  tz,tx,ty : real;
  GridInfo : GridPosType;
  quit : boolean;
  original : originaltype;
  demoquit : boolean;
  ObjectCount : integer;
  ObjectSelected : boolean;
  ObjectNumber : byte;
begin
 ObjectSelected := false;
 az := 0;
 ax := 0;
 ay := 0;
 If demo then
 begin
  az := 0;
  ax := 5;
  ay := 5;
  zoom := 3.0;
 end;
 tz := rz;
 tx := rx;
 ty := ry;
 ch := ' ';
 if demo then zoom := 3;
 for ObjectCount := 1 to Objects do
  rotate(DotCount[ObjectCount],DotXYZ[ObjectCount]^,rx,ry,rz,zoom,Lin,TriInfo,sn,cs,Color,TriSize[ObjectCount],GridInfo,
   original,false,NewX,newY,OldX,OldY,Operation,pastcolor,lc,rc,ObjectCount,ObjectInfo);
 flipvga;
 demoquit := false;
 repeat
  if demo then zoom := 3;
  MouseStuff(NewX,NewY,OldX,OldY,PastColor,Red);
  ChooseOperation(NewX,newY,OldX,OldY,Operation,pastcolor,lc,rc);
{  selectOp(Operation,NewX,NewY,OldX,OldY,PastColor); }
  ChooseObject(lc,OldX,OldY,ObjectSelected,pastcolor,ObjectNumber);
  ch := ' ';
  If keypressed then
  begin
   If demo then
   begin
    demoquit := true;
    operation := 2;
   end
   else
   begin
     ch := readkey;
     If ObjectSelected then
     begin
      case ch of
       '[' : ObjectInfo[ObjectNumber].YS := ObjectInfo[ObjectNumber].YS + ShiftRate;
       '/' : ObjectInfo[ObjectNumber].YS := ObjectInfo[ObjectNumber].YS - ShiftRate;
       ';' : ObjectInfo[ObjectNumber].XS := ObjectInfo[ObjectNumber].XS - ShiftRate;
      '''' : ObjectInfo[ObjectNumber].XS := ObjectInfo[ObjectNumber].XS + ShiftRate;
       'l' : ObjectInfo[ObjectNumber].ZS := ObjectInfo[ObjectNumber].ZS - ShiftRate;
       'p' : ObjectInfo[ObjectNumber].ZS := ObjectInfo[ObjectNumber].ZS + ShiftRate;

       'q' : If ObjectInfo[ObjectNumber].ZR < +30 then ObjectInfo[ObjectNumber].ZR := ObjectInfo[ObjectNumber].ZR + rate;
       'e' : If ObjectInfo[ObjectNumber].ZR > -30 then ObjectInfo[ObjectNumber].ZR := ObjectInfo[ObjectNumber].ZR - rate;
       'w' : If ObjectInfo[ObjectNumber].XR > -30 then ObjectInfo[ObjectNumber].XR := ObjectInfo[ObjectNumber].XR - rate;
       'z' : If ObjectInfo[ObjectNumber].XR < +30 then ObjectInfo[ObjectNumber].XR := ObjectInfo[ObjectNumber].XR + rate;
       'a' : If ObjectInfo[ObjectNumber].YR < +30 then ObjectInfo[ObjectNumber].YR := ObjectInfo[ObjectNumber].YR + rate;
       's' : If ObjectInfo[ObjectNumber].YR > -30 then ObjectInfo[ObjectNumber].YR := ObjectInfo[ObjectNumber].YR - rate;
      end;
       If ObjectInfo[ObjectNumber].XR > 360 then ObjectInfo[ObjectNumber].XR := ObjectInfo[ObjectNumber].XR - 360;
       If ObjectInfo[ObjectNumber].YR > 360 then ObjectInfo[ObjectNumber].YR := ObjectInfo[ObjectNumber].YR - 360;
       If ObjectInfo[ObjectNumber].ZR > 360 then ObjectInfo[ObjectNumber].ZR := ObjectInfo[ObjectNumber].ZR - 360;

       If ObjectInfo[ObjectNumber].XR < 0 then ObjectInfo[ObjectNumber].XR := ObjectInfo[ObjectNumber].XR + 360;
       If ObjectInfo[ObjectNumber].YR < 0 then ObjectInfo[ObjectNumber].YR := ObjectInfo[ObjectNumber].YR + 360;
       If ObjectInfo[ObjectNumber].ZR < 0 then ObjectInfo[ObjectNumber].ZR := ObjectInfo[ObjectNumber].ZR + 360;

       ObjectInfo[ObjectNumber].XR := (360 + ObjectInfo[ObjectNumber].XR) mod 360;
       ObjectInfo[ObjectNumber].YR := (360 + ObjectInfo[ObjectNumber].YR) mod 360;
       ObjectInfo[ObjectNumber].ZR := (360 + ObjectInfo[ObjectNumber].ZR) mod 360;
     end;
     case ch of
      '9' : If az > -30 then az := az - rate;
      '7' : if az < +30 then az := az + rate;
      '6' : if ay > -30 then ay := ay - rate;
      '4' : if ay < +30 then ay := ay + rate;
      '5' : if ax < +30 then ax := ax + rate;
      '8' : if ax > -30 then ax := ax - rate;
      '1' : zoom := zoom - 0.20;
      '3' : zoom := zoom + 0.20;
     end;
   end;
  end;
    tx := tx + ax;
    ty := ty + ay;
    tz := tz + az;
    If tx > 360 then tx := tx - 360;
    If ty > 360 then ty := ty - 360;
    if tz > 360 then tz := tz - 360;
    If tx < 0 then tx := tx + 360;
    if ty < 0 then ty := ty + 360;
    if tz < 0 then tz := tz + 360;
    rx := round(tx);
    ry := round(ty);
    rz := round(tz);
    RX := (360 + RX) mod 360;
    RY := (360 + RY) mod 360;
    RZ := (360 + RZ) mod 360;

    If (ch = 'q') or (ch = 'w') or (ch = 'e') or (ch = 'a') or (ch = 's') or (ch = 'z') or
       (ch = '[') or (ch = '/') or (ch = ';') or (ch = '''') or (ch = 'p') or (ch = 'l') or
       ((ch = '1') or (ch = '3')) or ((ax <> 0) or (ay <> 0) or (az <> 0)) then
    begin
     box(10,0,210,199,black,vga);
     For ObjectCount := 1 to Objects do
     rotate(Dotcount[ObjectCount],DotXYZ[ObjectCount]^,round(rx),round(ry),round(rz),zoom,Lin,
       TriInfo,sn,cs,Color,TriSize[ObjectCount],GridInfo,original,false,
       NewX,newY,OldX,OldY,Operation,pastcolor,lc,rc,ObjectCount,Objectinfo);

    end;
quit := false;
if Lin and (operation <> 9) then
 quit := TRUE;
If not(lin) and (operation <> 7) then
 quit := true;
 until (quit) or (demoquit);{not(quit)}

end;


{Rename to Delete Object later}
procedure DeletePanel(dotcount:integer;DotXYZ:DotType;
          var rx,ry,rz:integer;
          var zoom:real;Lin:boolean;var TriInfo:TriLocation;
          sn,cs:AngleType; Color:Clr; var TriSize:integer;
          var NewX,NewY,OldX,OldY: integer; var PastColor:byte;
          var lc,rc : boolean;var operation : integer; Objects : integer;objectinfo : objectinfotype);
var
  ch : char;
  az,ax,ay : real;
  tz,tx,ty : real;
  GridInfo : GridPosType;
  TriToDelete : integer;
  original : originaltype;
  CheckTriNum : integer;
  quit,error : boolean;
  ObjectCount : integer;
begin
 quit := false;
 az := 0;
 ax := 0;
 ay := 0;
 tz := rz;
 tx := rx;
 ty := ry;
 ch := ' ';
 For ObjectCount := 1 to Objects do
 rotate(DotCount,DotXYZ,rx,ry,rz,zoom,Lin,
      TriInfo,sn,cs,Color,TriSize,GridInfo,original,false,
      NewX,newY,OldX,OldY,Operation,pastcolor,lc,rc,ObjectCount,objectinfo);
 repeat
  MouseStuff(NewX,NewY,OldX,OldY,PastColor,Red);
  ChooseOperation(NewX,newY,OldX,OldY,Operation,pastcolor,lc,rc);
  selectOp(Operation,NewX,NewY,OldX,OldY,PastColor);

  ch := ' ';
  If keypressed then
  begin
    ch := readkey;
    case ch of
     '9' : If az > -30 then az := az - rate;
     '7' : if az < +30 then az := az + rate;
     '6' : if ay > -30 then ay := ay - rate;
     '4' : if ay < +30 then ay := ay + rate;
     '5' : if ax < +30 then ax := ax + rate;
     '8' : if ax > -30 then ax := ax - rate;
     '1' : zoom := zoom - 0.20;
     '3' : zoom := zoom + 0.20;
    end;
  end;
    tx := tx + ax;
    ty := ty + ay;
    tz := tz + az;
    If tx > 360 then tx := tx - 360;
    If ty > 360 then ty := ty - 360;
    if tz > 360 then tz := tz - 360;
    If tx < 0 then tx := tx + 360;
    if ty < 0 then ty := ty + 360;
    if tz < 0 then tz := tz + 360;
    rx := round(tx);
    ry := round(ty);
    rz := round(tz);
    RX := (360 + RX) mod 360;
    RY := (360 + RY) mod 360;
    RZ := (360 + RZ) mod 360;

    If ((ch = '1') or (ch = '3'))  or ((ax <> 0) or (ay <> 0) or (az <> 0)) then
     for ObjectCount := 1 to Objects do
     rotate(Dotcount,DotXYZ,round(rx),round(ry),round(rz),zoom,Lin,TriInfo,sn,cs,Color,TriSize,GridInfo,original,false,
     NewX,newY,OldX,OldY,Operation,pastcolor,lc,rc, ObjectCount,objectinfo);
 if (OldX <= 199) and LClick(lc) and mouseleft then
 begin
  TriToDelete := PastColor;
  error := true;
  for CheckTriNum := 1 to 255{Original[TriToDelete]} do
  begin
   If TriToDelete = Original[CheckTriNum] then
    error := false;
  end;
  If not(error) then
 BEGIN
  pal(TriToDelete,255,255,255);
  for CheckTriNum := Original[TriToDelete] to TriSize-1 do
  begin
   TriInfo[CheckTriNum] := TriInfo[CheckTriNum + 1];
  end;
  pal(TriToDelete,255,0,0);
  TriSize := TriSize - 1;
  quit := true;
 END
 else
 begin
 sound(1000);
 delay(250);
 nosound;
 end;
  operation := 5;
 end;

until (Operation <> 3) or (quit) or (ch = '2')
end;


procedure DrawTri(TempTri : TriP; Dot : DotType);
var
 x : integer;
BEGIN
{ for x := 1 to 2 do }
 begin
{  If TempTri[x].S1 = 5 then   }
   Line(Dot[TempTri.P1].X + 110 ,ABS(Dot[TempTri.p1].Y - 99) + 100,
     Dot[TempTri.p2].X + 110 ,ABS(Dot[TempTri.P2].Y - 99) + 100,Blue,VGA);
   Line(Dot[TempTri.P2].X + 110 ,ABS(Dot[TempTri.p2].Y - 99) + 100,
     Dot[TempTri.p3].X + 110 ,ABS(Dot[TempTri.P3].Y - 99) + 100,Blue,VGA);
   Line(Dot[TempTri.P3].X + 110 ,ABS(Dot[TempTri.p3].Y - 99) + 100,
     Dot[TempTri.p1].X + 110 ,ABS(Dot[TempTri.P1].Y - 99) + 100,Blue,VGA);
{  If TempTri[x].S1 = 4 then      }
   Line(ABS(Dot[TempTri.P1].Z-99) + 10,ABS(Dot[TempTri.P1].Y-99) + 100 ,
     ABS(Dot[TempTri.P2].Z-99) + 10,ABS(Dot[TempTri.P2].Y-99) + 100 ,Blue,VGA);
   Line(ABS(Dot[TempTri.P2].Z-99) + 10,ABS(Dot[TempTri.P2].Y-99) + 100 ,
     ABS(Dot[TempTri.P3].Z-99) + 10,ABS(Dot[TempTri.P3].Y-99) + 100 ,Blue,VGA);
   Line(ABS(Dot[TempTri.P3].Z-99) + 10,ABS(Dot[TempTri.P3].Y-99) + 100 ,
     ABS(Dot[TempTri.P1].Z-99) + 10,ABS(Dot[TempTri.P1].Y-99) + 100 ,Blue,VGA);
{  If TempTri[x].S1 = 8 then    }
   Line(Dot[TempTri.P1].X + 110 ,ABS(Dot[TempTri.P1].Z-99) ,
     Dot[TempTri.P2].X + 110 ,ABS(Dot[TempTri.P2].Z-99) ,Blue,VGA);
   Line(Dot[TempTri.P2].X + 110 ,ABS(Dot[TempTri.P2].Z-99) ,
     Dot[TempTri.P3].X + 110 ,ABS(Dot[TempTri.P3].Z-99) ,Blue,VGA);
   Line(Dot[TempTri.P3].X + 110 ,ABS(Dot[TempTri.P3].Z-99) ,
     Dot[TempTri.P1].X + 110 ,ABS(Dot[TempTri.P1].Z-99) ,Blue,VGA);
{  if TempTri[x].S1 = 6 then  }
   Line(Dot[TempTri.P1].Z + 210,abs(Dot[TempTri.P1].Y-99) + 100 ,
     Dot[TempTri.P2].Z + 210,abs(Dot[TempTri.P2].Y-99) + 100 ,Blue,VGA);
   Line(Dot[TempTri.P2].Z + 210,abs(Dot[TempTri.P2].Y-99) + 100 ,
     Dot[TempTri.P3].Z + 210,abs(Dot[TempTri.P3].Y-99) + 100 ,Blue,VGA);
   Line(Dot[TempTri.P3].Z + 210,abs(Dot[TempTri.P3].Y-99) + 100 ,
     Dot[TempTri.P1].Z + 210,abs(Dot[TempTri.P1].Y-99) + 100 ,Blue,VGA);

 end;

 X := 1;{This will allow the next section of the triangle drawingn code
         to draw a line from Line(1) to Line(1 + 2) i.e. Line(3)}


{End of triangle drawing segment}
END;








procedure ChoosePos(OldX,OldY : integer;var OldPos,Position,OverPosition : integer);
begin
 OverPosition := 0;
 If (OldY <= 99) and (OldX >=100 ) and (OldX <= 199 ) and (OldPos <> 8) then
  begin OldPos := position; position := 8;end;
 If (OldY >= 100) and (OldX >=100) and (OldX <= 199) and (OldPos <> 5)then
  begin OldPos := position; position := 5;end;
 If (OldY >= 100) and (OldX <=99 ) and (OldPos <> 4) then
  begin OldPos := position; position := 4;end;
 If (OldY >= 100) and (OldX >=200 ) and (OldPos <> 6) then
  begin OldPos := position; position := 6;end;

 If (OldY <= 99) and (OldX >=100 ) and (OldX <= 199 ) then
  begin OverPosition :=8;end;
 If (OldY >= 100) and (OldX >=100) and (OldX <= 199) then
  begin OverPosition :=5;end;
 If (OldY >= 100) and (OldX <=99 ) then
  begin OverPosition :=4;end;
 If (OldY >= 100) and (OldX >=200 ) then
  begin OverPosition :=6;end;
end;





var
 SecX,SecY,NewX,NewY,OldX,OldY,x,y,OldPos,position : integer;
 dotcount: DotCountType;
 ch : char; RC,LC : boolean;


 Dot : DotObjType; {Current level of 16 objects per PATCH}
 ObjectCount : integer;
 ObjectInfo: ObjectInfoType;

{ Sides : SideType;}
 PastColor : byte ; beeptest,PastX,PastY : integer;
 RotX,RotY,RotZ,DotOld,DCX,DCY : integer;
 infile,otherfile : text;
 cs,sn : ^AngleType;
 ReplaceBigRot : ^BigRotType;
 BRX,BRY: integer;
 OutBaseFile,BaseFile : string[7];
 Top, Front, Left, Right,Triangle: boolean;
 PosShowTemp : char;
 zoom : real;
 color: clr;
 TriCount : TriCountType;
 TriInfo : TriLocation;
 TriPiece : TriP;
 TriCol : TriColor;
 XX,YY,ZZ : integer;
 Comp1,Comp2 : integer;
 TriTrans : Trip;
 Dist1,Dist2 : real;
 X1,Y1,Z1,X2,Y2,Z2 : real;
 palette,junkpal : paltype;
 TempColHolder : Trip;
 paledit :byte;
 Operation : integer;
 OverPosition : integer;
 OldTriSize : integer;
 error: boolean;
 success: boolean;
 LastOn : integer;
 LeftClicked: boolean;
 RightClicked: boolean;
 ViewFile : string[8];
 Command: string[79];
 f,FO : text;
 version: string;
 label 1;

begin
 black := 0;
 white := 253;
 blue := 254;
 red := 255;
 demo := false;
 new(ReplaceBigRot);
 for ObjectCount := 1 to MaxObj do
 begin
  new(Dot[ObjectCount]);
  new(TriInfo[ObjectCount]);
 end;
 new(sn);
 new(cs);
 LeftClicked := FALSE;
 RightClicked := FALSE;
 SineMovement := 0;
 Zoom := 1;
 for ObjectCount := 1 to MaxObj do
  TriCount[ObjectCount] := 0;{The number of triangles}
 for x := -30 to 390 do
  begin
   sn^[x] := sin(rad(x));
   cs^[x] := cos(rad(x));
  end;
 for ObjectCount := 1 to MaxObj do
  for DCX := 1 to 256 do
   begin
    Dot[ObjectCount]^[DCX].X := -1; {From now on each character is allowed 16 objects}
    Dot[ObjectCount]^[DCX].Y := -1;
    Dot[ObjectCount]^[DCX].Z := -1;
    Color[ObjectCount][DCX] := 15;
    dotcount[ObjectCount] := 0;
   end;

 DotOld := 1;
 write('Enter the base file name, i.e. without the ''.3DI'' extension: ');
 readln(basefile);

 if basefile = '' then
  begin
   Top := FALSE; Front := FALSE; Left := FALSE; Right := FALSE;
   write('Please enter a new base file name less than 7 characters long:');
   readln(BaseFile);
   writeln('If there is a graphic for the front view of the object, enter its filename');
   write  ('without the .GIF ending, or else press enter: ');
   readln(ViewFile);
   If ViewFile <> '' then
   begin
    Front := true;
    assign(f,'Temp.TMP');
    rewrite(f);
     writeln(f,BaseFile + 'f.3di');
     writeln(f,ViewFile);
    close(f);
  SwapVectors;
  Exec(GetEnv('COMSPEC'), '/C transexe.exe');
  SwapVectors;
   end;
   writeln('If there is a graphic for the left view of the object, enter its filename');
   write  ('without the .GIF ending, or else press enter: ');
   readln(ViewFile);
   If ViewFile <> '' then
   begin
    Left := true;
    assign(f,'Temp.TMP');
    rewrite(f);
     writeln(f,BaseFile + 'l.3di');
     writeln(f,ViewFile);
    close(f);
    swapvectors;
    exec(GetEnv('COMSPEC'),'/C Transexe.exe');
    swapvectors;
   end;
   writeln('If there is a graphic for the right view of the object, enter its filename');
   write  ('without the .GIF ending, or else press enter: ');
   readln(ViewFile);
{   writeln('View File has been read');}
   If ViewFile <> '' then
   begin
    right := true;
    assign(f,'Temp.TMP');
    rewrite(f);
     writeln(f,BaseFile + 'r.3di');
     writeln(f,ViewFile);
    close(f);
    swapvectors;
    exec(GetEnv('COMSPEC'),'/C Transexe.exe');
    swapvectors;
   end;
   writeln('If there is a graphic for the above view of the object, enter its filename');
   write  ('without the .GIF ending, or else press enter: ');
   readln(ViewFile);
{   writeln('View File has been read');}
   If ViewFile <> '' then
   begin
    Top := true;
    assign(f,'Temp.TMP');
    rewrite(f);
     writeln(f,BaseFile + 't.3di');
     writeln(f,ViewFile);
    close(f);
    swapvectors;
    exec(GetEnv('COMSPEC'),'/C Transexe.exe');
    swapvectors;
   end;
   writeln('Begining data creation');
   writeln(BaseFile);
   assign(fo,BaseFile + '.3di');
   rewrite(fo);
    writeln(fo,Top);
    writeln(fo,Front);
    writeln(fo,Left);
    writeln(fo,Right);
    writeln(fo,0);
    writeln(fo,0);
   close(fo);
   writeln('Data creation complete');
  end;
 If (basefile = 'DEMO') or (basefile = 'demo')  then
 begin
  demo := true;
  basefile := '3di';
 end;
 assign(infile,basefile + '.3di');
 reset(infile);
 if not(eof(infile)) then
 begin
 {New section to handle OBJECT/PATCH file formats}
  readln(infile, version);
  if version <> 'patch' then
  begin
   writeln('This program can not edit 3DI OBJECT files');
   goto 1;
  end;
  readln(infile, objects);
  for ObjectCount := 1 to Objects do
  begin
   readln(infile,ObjectInfo[ObjectCount].XS,ObjectInfo[ObjectCount].YS,
                 ObjectInfo[ObjectCount].ZS,ObjectInfo[ObjectCount].XR,
                 ObjectInfo[ObjectCount].YR,ObjectInfo[ObjectCount].ZR);
   readln(infile,ObjectInfo[ObjectCount].Name);
   assign(otherfile, ObjectInfo[ObjectCount].Name);
    reset(otherfile);
    readln(otherfile,version);
    if version = 'object' then
    begin
     readln(otherfile,version);
     readln(otherfile,version);
     readln(otherfile,version);
     readln(otherfile,version);

     Load(otherfile,dotcount[ObjectCount],Dot[ObjectCount]^{,Sides});
     writeln(dotcount[ObjectCount]);
     LoadTri(otherfile,ObjectCount, TriInfo, TriCount[ObjectCount]);
     writeln(TriCount[ObjectCount]);
    end
    else
    writeln('File',ObjectInfo[ObjectCount].Name,' is not a 3DI object file');
   close(otherfile);
  end;
 end;
 close(infile);
 If graphics then setmcga;

 setupvirtual;

 Pal(Black,0,0,0);
 pal(White,255,255,255);
 pal(Blue,0,0,255);
 pal(Red,255,0,0);
 cls(0,vaddr);
 clear;                  {299}
 clearbox; limitmouse(0,0,319,199);
 for x := 0 to 63 do
  box(0,x*2,4,x*2 + 1,x,VGA);
 for x := 64 to 127 do
  box(5,(x-64)*2,9,(x-64)*2 + 1,x,VGA);
 for x := 128 to 191 do
  box(310,(x-128)*2,314,(x-128)*2 + 1,x,VGA);
 for x := 192 to 255 do
  box(315,(x-192)*2,319,(x-192)*2 + 1,x,VGA);

 {drawdots(dotcount[,Dot^,White); }{I've ditched the draw dots segment
                                  because the screen is going to be 200x200
                                  with the extra space going to the menu}

 RotX := 0; RotY := 180; RotZ := 0;
 rc := FALSE; lc := FALSE;
 OldPos := 5;
 Position := 0;
 for PalEdit := 0 to 255 do
  getpal(Paledit,Palette[PalEdit].R,Palette[PalEdit].B,Palette[PalEdit].G);
 repeat
    If Demo then
    begin
      operation := 9;
      if keypressed then operation := 2;
    end;


  ChooseOperation(NewX,newY,OldX,OldY,Operation,pastcolor,lc,rc);


  If Operation = 9 then
  begin
   for BRY := 0 to 199 do
    for BRX := 0 to 199 do   {Take the screen info}
     ReplaceBigRot^[BRX,BRY]:= getpixel(BRX,BRY,VGA);
{This is the segment that will handle full screen rotation}
    Rotation(DotCount,Dot,rotx,roty,rotz,zoom,TRUE,TriInfo,sn^,cs^,Color,TriCount,
            NewX,NewY,OldX,OldY,PastColor,lc,rc,operation,Objects,objectinfo);
   for BRY := 0 to 199 do
    for BRX := 0 to 199 do    {Put back the screen}
     putpixel(BRX,BRY,ReplaceBigRot^[BRX,BRY],VGA);
{   for PalEdit := 0 to 255 do
    pal(PalEdit,Palette[PalEdit].R,Palette[PalEdit].B,Palette[PalEdit].G);}
  end;

 ChoosePos(OldX,OldY,OldPos,Position,OverPosition);
{}{}{}{}{}{}{}{}
{}{}{}{}{}{}{}{}
   MouseStuff(NewX,NewY,OldX,OldY,PastColor,White);
  ch := ' ';
If OldPos <> Position then
  begin
    select(position,NewX,NewY,OldX,OldY,PastColor);
  end;

  If keypressed then
   begin
    ch := readkey;
   end;
until (operation = 2) or (ch = '2');
settext;
if not(demo) then
begin
 write('Enter the output base file name, i.e. without the ''s.3DI'' extension: ');
 readln(OutBaseFile);
 writeln('Writing patch file');
 If OutBaseFile = '' then OutBaseFile := BaseFile;
 assign(infile,OutBaseFile + '.3di');
 rewrite(infile);
 writeln(infile,'patch');
 writeln(infile,objects);
 For ObjectCount := 1 to Objects do
 begin
   writeln(infile,ObjectInfo[ObjectCount].XS,' ',ObjectInfo[ObjectCount].YS,' ',
                 ObjectInfo[ObjectCount].ZS,' ',ObjectInfo[ObjectCount].XR,' ',
                 ObjectInfo[ObjectCount].YR,' ',ObjectInfo[ObjectCount].ZR);
   writeln(infile,ObjectInfo[ObjectCount].Name);
 end;
 close(infile);
 settext;
 writeln('PATCH file writing completed');
 writeln('Creating RWX file');
 assign(infile, OutBaseFile +'.RWX');
 rewrite(infile);
 writeln(infile, '# ',OutBaseFile + '.RWX');
 writeln(infile, '# RWX File created by 3DI Patch version 0.8');
 writeln(infile);
 writeln(infile,'ModelBegin');
 For ObjectCount := 1 to Objects do
 begin
  writeln(infile,'  ProtoBegin ',ObjectInfo[ObjectCount].Name);
  for x := 1 to dotcount[ObjectCount] do
  begin
   writeln(infile,'    Vertex ',(Dot[ObjectCount]^[x].X + ObjectInfo[ObjectCount].XS - 50)/1000:3:3,' ',
                             (Dot[ObjectCount]^[x].Y + ObjectInfo[ObjectCount].YS - 50)/1000:3:3,' ',
                             (abs(Dot[ObjectCOunt]^[x].Z-99) + ObjectInfo[ObjectCount].ZS - 50)/1000:3:3);
   writeln(infile,'# XS:',ObjectInfo[ObjectCount].XS,' YS:',ObjectInfo[ObjectCount].YS,' ZS:',ObjectInfo[ObjectCount].ZS);
  end;
  writeln(infile,'    Texture NULL');
  writeln(infile,'    Surface .5 .3 .1');  {}
  writeln(infile,'    LightSampling Vertex');
  writeln(infile,'    Opacity 1.0');
  for x := 1 to TriCount[ObjectCount] do
  begin
   writeln(infile,'          Color ',TriInfo[ObjectCount]^[x].R/63:3:3,' ',
                             TriInfo[ObjectCount]^[x].B/63:3:3,' ',
                             TriInfo[ObjectCount]^[x].G/63:3:3);
   writeln(infile,'          Triangle ',TriInfo[ObjectCount]^[x].P2 : 3,' ',
                                TriInfo[ObjectCount]^[x].P3 : 3,' ',
                                TriInfo[ObjectCount]^[x].P1 : 3);
   writeln(infile,'          Triangle ',TriInfo[ObjectCount]^[x].P1 : 3,' ',
                                TriInfo[ObjectCount]^[x].P3 : 3,' ',
                                TriInfo[ObjectCount]^[x].P2 : 3);
   writeln(infile);
  end;
  writeln(infile,'  ProtoEnd #',ObjectInfo[ObjectCount].Name);
 end;
 writeln(infile,'  ClumpBegin');
 writeln(infile,'    Hints HS EDITABLE');
 writeln(infile,'    Translate 0.0 0.0 0.0');
 for x := 1 to Objects do
  writeln(infile,'    ProtoInstance ',ObjectInfo[x].Name);
 writeln(infile,'  ClumpEnd');
 writeln(infile,'ModelEnd');
 close(infile);
 1: x:=x;
end;
 dispose(ReplaceBigRot);
 for ObjectCount := 1 to MaxObj do
 begin
  dispose(Dot[ObjectCount]);
  dispose(TriInfo[ObjectCount]);
 end;
 dispose(sn);
 dispose(cs);

end.
